diff --git a/src/tds/unittests/numeric.c b/src/tds/unittests/numeric.c
index ecf447e..3e987e9 100644
--- a/src/tds/unittests/numeric.c
+++ b/src/tds/unittests/numeric.c
@@ -23,14 +23,14 @@
 
 /* test numeric scale */
 
-static char software_version[] = "$Id: numeric.c,v 1.4 2005/07/28 08:06:31 freddy77 Exp $";
+static char software_version[] = "$Id: numeric.c,v 1.5 2009/01/16 20:27:59 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int g_result = 0;
 static TDSCONTEXT ctx;
 
 static void
-test0(const char *src, int prec, int scale, int prec2, int scale2)
+test0(const char *src, int prec, int scale, int prec2, unsigned char scale2)
 {
 	int i;
 	char buf[256];
@@ -43,7 +43,7 @@ test0(const char *src, int prec, int scale, int prec2, int scale2)
 	memset(&cr.n, 0, sizeof(cr.n));
 	cr.n.precision = prec;
 	cr.n.scale = scale;
-	if (tds_convert(&ctx, SYBVARCHAR, src, strlen(src), SYBNUMERIC, &cr) < 0) {
+	if (tds_convert(&ctx, SYBVARCHAR, src, (TDS_UINT)strlen(src), SYBNUMERIC, &cr) < 0) {
 		fprintf(stderr, "Error getting numeric %s(%d,%d)\n", src, prec, scale);
 		exit(1);
 	}
@@ -68,7 +68,7 @@ test0(const char *src, int prec, int scale, int prec2, int scale2)
 	}
 	cr.n.precision = prec2;
 	cr.n.scale = scale2;
-	if (tds_convert(&ctx, SYBVARCHAR, src, strlen(src), SYBNUMERIC, &cr) < 0)
+	if (tds_convert(&ctx, SYBVARCHAR, src, (TDS_UINT)strlen(src), SYBNUMERIC, &cr) < 0)
 		strcpy(buf, "error");
 
 	/* change scale with function */
diff --git a/src/tds/vstrbuild.c b/src/tds/vstrbuild.c
index af7a519..92b4065 100644
--- a/src/tds/vstrbuild.c
+++ b/src/tds/vstrbuild.c
@@ -35,7 +35,7 @@
 #include "tds.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: vstrbuild.c,v 1.15 2008/01/24 21:14:55 freddy77 Exp $");
+TDS_RCSID(var, "$Id: vstrbuild.c,v 1.16 2009/01/16 20:27:59 jklowden Exp $");
 
 struct string_linked_list
 {
@@ -49,7 +49,7 @@ struct string_linked_list
  */
 
 static char *
-norm_fmt(const char *fmt, int fmtlen)
+norm_fmt(const char *fmt, size_t fmtlen)
 {
 	char *newfmt;
 	char *cp;
@@ -102,7 +102,7 @@ tds_vstrbuild(char *buffer, int buflen, int *resultlen, char *text, int textlen,
 
 	*resultlen = 0;
 	if (textlen == TDS_NULLTERM) {
-		textlen = strlen(text);
+		textlen = (int)strlen(text);
 	}
 	if ((newformat = norm_fmt(formats, formatlen)) == NULL) {
 		return TDS_FAIL;
diff --git a/src/tds/write.c b/src/tds/write.c
index 74f85a3..5e70c56 100644
--- a/src/tds/write.c
+++ b/src/tds/write.c
@@ -49,7 +49,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: write.c,v 1.76 2006/12/26 14:56:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: write.c,v 1.77 2009/01/16 20:27:59 jklowden Exp $");
 
 /**
  * \addtogroup network
@@ -61,9 +61,9 @@ TDS_RCSID(var, "$Id: write.c,v 1.76 2006/12/26 14:56:21 freddy77 Exp $");
  *		much like read() and memcpy()
  */
 int
-tds_put_n(TDSSOCKET * tds, const void *buf, int n)
+tds_put_n(TDSSOCKET * tds, const void *buf, size_t n)
 {
-	int left;
+	size_t left;
 	const unsigned char *bufp = (const unsigned char *) buf;
 
 	assert(n >= 0);
@@ -82,7 +82,7 @@ tds_put_n(TDSSOCKET * tds, const void *buf, int n)
 		} else {
 			memset(tds->out_buf + tds->out_pos, 0, left);
 		}
-		tds->out_pos += left;
+		tds->out_pos += (unsigned int)left;
 		n -= left;
 	}
 	return 0;
@@ -108,13 +108,13 @@ tds_put_string(TDSSOCKET * tds, const char *s, int len)
 
 	if (len < 0) {
 		if (client->min_bytes_per_char == 1) {	/* ascii or UTF-8 */
-			len = strlen(s);
+			len = (int)strlen(s);
 		} else if (client->min_bytes_per_char == 2 && client->max_bytes_per_char == 2) {	/* UCS-2 or variant */
 			const char *p = s;
 
 			while (p[0] || p[1])
 				p += 2;
-			len = p - s;
+			len = (int)(p - s);
 
 		} else {
 			assert(client->min_bytes_per_char < 3);	/* FIXME */
@@ -162,7 +162,7 @@ tds_put_string(TDSSOCKET * tds, const char *s, int len)
 		tds_put_n(tds, outbuf, poutbuf - outbuf);
 	}
 	tdsdump_log(TDS_DBG_NETWORK, "tds_put_string wrote %d bytes\n", (int) bytes_out);
-	return bytes_out;
+	return (int)bytes_out;
 }
 
 int
@@ -269,7 +269,7 @@ tds_put_smallint(TDSSOCKET * tds, TDS_SMALLINT si)
 int
 tds_put_byte(TDSSOCKET * tds, unsigned char c)
 {
-	if (tds->out_pos >= tds->env.block_size)
+	if (tds->out_pos >= (unsigned int)tds->env.block_size)
 		tds_write_packet(tds, 0x0);
 	tds->out_buf[tds->out_pos++] = c;
 	return 0;

